"""
15-110 Hw6 - Social Media Analytics Project
Name:
AndrewID:
"""

import hw6_social_tests as test

project = "Social" # don't edit this

### WEEK 1 ###

import pandas as pd
import nltk
nltk.download('vader_lexicon', quiet=True)
from nltk.sentiment.vader import SentimentIntensityAnalyzer
import matplotlib.pyplot as plt; plt.rcdefaults()
import numpy as np

def makeDataFrame(filename):
    return

def parseName(fromString):
    return

def parsePosition(fromString):
    return

def parseState(fromString):
    return

endChars = [ " ", "\n", "#", ".", ",", "?", "!", ":", ";", ")" ]
def findHashtags(message):
    return

def getRegionFromState(stateDf, state):
    return

def addColumns(data, stateDf):
    return


### WEEK 2 ###

def findSentiment(classifier, message):
    score = classifier.polarity_scores(message)['compound']
    return

def addSentimentColumn(data):
    classifier = SentimentIntensityAnalyzer()
    return

def getDataCountByState(data, colName, dataToCount):
    return

def getDataForRegion(data, colName):
    return

def getHashtagRates(data):
    return

def mostCommonHashtags(hashtags, count):
    return

def getHashtagSentiment(data, hashtag):
    return


### WEEK 3 ###

def graphStateCounts(stateCounts, title):
    return

def graphTopNStates(stateCounts, stateFeatureCounts, n, title):
    return

def graphRegionComparison(regionDicts, title):
    return

def graphHashtagSentimentByFrequency(df):
    return


#### WEEK 3 PROVIDED CODE ####
"""
Expects 3 lists - one of x labels, one of data labels, and one of data values - and a title.
You can use it to graph any number of datasets side-by-side to compare and contrast.
"""
def sideBySideBarPlots(xLabels, labelList, valueLists, title):
    x = np.arange(len(xLabels)) # gets the indexes of the bars
    width = 0.8 / len(labelList)  # the width of the bars
    fig, ax = plt.subplots()
    for index in range(len(valueLists)):
        ax.bar(x - 0.4 + width*(index+0.5), valueLists[index], width, label=labelList[index])
    ax.set_xticks(x)
    ax.set_xticklabels(xLabels)
    plt.xticks(rotation="vertical")
    ax.legend()
    plt.title(title)
    fig.tight_layout()
    plt.show()

"""
Expects two lists of probabilities and a list of labels (words) all the same length
and plots the probabilities of x and y, labels each point, and puts a title on top.
Expects that the y axis will be from -1 to 1. If you want a different y axis, change plt.ylim
"""
def scatterPlot(xValues, yValues, labels, title):
    fig, ax = plt.subplots()

    plt.scatter(xValues, yValues)

    # make labels for the points
    for i in range(len(labels)):
        plt.annotate(labels[i], # this is the text
                    (xValues[i], yValues[i]), # this is the point to label
                    textcoords="offset points", # how to position the text
                    xytext=(0, 10), # distance from text to points (x,y)
                    ha='center') # horizontal alignment can be left, right or center

    ax.plot([0, 1], [0.5, 0.5], color='black', transform=ax.transAxes)
    plt.title(title)
    plt.ylim(-1, 1)
    plt.show()


### RUN CODE ###

# This code runs the test cases to check your work
if __name__ == "__main__":
    print("\n" + "#"*15 + " WEEK 1 TESTS " +  "#" * 16 + "\n")
    test.week1Tests()
    print("\n" + "#"*15 + " WEEK 1 OUTPUT " + "#" * 15 + "\n")
    test.runWeek1()

    ## Uncomment these for Week 2 ##
    """print("\n" + "#"*15 + " WEEK 2 TESTS " +  "#" * 16 + "\n")
    test.week2Tests()
    print("\n" + "#"*15 + " WEEK 2 OUTPUT " + "#" * 15 + "\n")
    test.runWeek2()"""

    ## Uncomment these for Week 3 ##
    """print("\n" + "#"*15 + " WEEK 3 OUTPUT " + "#" * 15 + "\n")
    test.runWeek3()"""